Bug 80020 - FILEOPEN: Impress/Draw ODF import; style's parent style is lost
Summary: FILEOPEN: Impress/Draw ODF import; style's parent style is lost
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Impress (show other bugs)
Version:
(earliest affected)
4.3.0.0.beta2
Hardware: Other All
: high critical
Assignee: Tobias Lippert
URL:
Whiteboard: odf target:4.4.0 target:4.3.0
Keywords: dataLoss, regression
Depends on:
Blocks: mab4.3
  Show dependency treegraph
 
Reported: 2014-06-14 09:38 UTC by Pierre C
Modified: 2015-12-18 09:53 UTC (History)
5 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Pierre C 2014-06-14 09:38:11 UTC
Step to reproduce

1 create a new presentation
2 create a new style inherit from text for example
3 save presentation

4 reopen presentation ==> lost of inherit

Rem opening a existing presentation loose inherit for all styles

so I think we can add data-loss for this bug (to be confirmed)

Of course, it works fine with LO 4.2.4
Comment 1 pierre-yves samyn 2014-06-14 10:41:43 UTC
Hi

I reproduce on windows 7/64 & Version: 4.3.0.0.beta2
Build ID: a06aa316117a6ff0f05c697c82831c227812d810

So I set status to New

Was ok with Version: 4.2.5.1
Build ID: 881bb88abfe2992c6cede97c23e64a9885de87de 

Regards
Pierre-Yves
Comment 2 Pierre C 2014-07-04 16:56:08 UTC
Still in 4.3.0RC2...
Comment 3 Cor Nouws 2014-07-08 08:38:47 UTC
When I save a file in 4.3.x and open in 4.5.x, it is still OK

 > The information is lost on opening
Comment 4 Cor Nouws 2014-07-08 11:48:54 UTC
of course one can link styles again, but boxes will also have changed size and so, which is a PITA to repair...
Comment 5 Pierre C 2014-07-14 14:26:46 UTC
4.3.0 is in two days, and this data-loss bug is not solved. Too bad
Comment 6 Michael Stahl (CIB) 2014-07-14 18:04:19 UTC
bibisect range:

dd1050b182260a26a1d0ba6d0ef3a6fecc3f4e07..c59b3d6c5c8096486730007d9b9b053793b90b1e

regression from:

commit e955433c3574cb602dedba96bc645898f97858bf
Author:     Tobias Lippert <drtl@fastmail.fm>
AuthorDate: Wed Mar 5 19:51:58 2014 +0100
Commit:     Caolán McNamara <caolanm@redhat.com>
CommitDate: Mon Mar 10 12:10:15 2014 -0500

    Use SfxStyleSheetIterator to iterate over style sheets in sd/stlsheet.cxx
Comment 7 Tobias Lippert 2014-07-14 20:02:22 UTC
Dear all,
sorry for introducing that regression. I was not aware of it until Martin added me to the cc list.
I have written a fix which works on my machine. I am not familiar with the inheritance. Please check whether I tested it correctly.

I have tested it as follows:
1. Create a new draw document
2. Open Styles and Formatting
3. Right-click the style "text" 
4. Choose new in the context menu
5. Enter any name
6. Save document
7. Close document
8. Re-open document

Without the fix, the new style is on the same level as "Default"
With the fix, the new style is one level below "text"

I will submit a fix asap and ask someone in the irc to review it.
Comment 8 Tobias Lippert 2014-07-14 20:29:19 UTC
The link to the fix can be found below. I did an end-to-end test, as described in the comment above. I will add a unittest for the fix later, but the fix should help to resolve the bug in 4.3.0.
https://gerrit.libreoffice.org/#/c/10309/
Comment 9 Commit Notification 2014-07-15 09:25:28 UTC
Tobias Lippert committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=61cf536f0400284a5ff85d1a84c9dee72ead3fbf

fdo#80020 Fix regression for style sheet inheritance



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 10 Commit Notification 2014-07-15 09:40:23 UTC
Tobias Lippert committed a patch related to this issue.
It has been pushed to "libreoffice-4-3":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=980b3fc921b6c22634ea63cd7aa264b520da0ce4&h=libreoffice-4-3

fdo#80020 Fix regression for style sheet inheritance


It will be available in LibreOffice 4.3.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 11 Commit Notification 2014-07-15 14:43:39 UTC
Tobias Lippert committed a patch related to this issue.
It has been pushed to "libreoffice-4-3-0":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=e662655c6afacc9c67d2381411d838e2be16d3ed&h=libreoffice-4-3-0

fdo#80020 Fix regression for style sheet inheritance


It will be available already in LibreOffice 4.3.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 12 Eike Rathke 2014-07-15 14:49:43 UTC
Let's call this fixed.
Comment 13 Pierre C 2014-07-17 12:32:01 UTC
YEP ! No problem with 4.3.0.3
Comment 14 Commit Notification 2015-07-07 20:45:46 UTC
Varun committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=91949b62505b4159ad930dca89d2cc9eba082807

Added Test for tdf#80020 Impress style inheritance

It will be available in 5.1.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 15 Robinson Tryon (qubit) 2015-12-18 09:53:16 UTC
Migrating Whiteboard tags to Keywords: (dataloss)
[NinjaEdit]